////////////////////////////////////////////////////////////////////
// TS24 test tool TX
//      using TS24 DEVBD
//
// PORTA 
//    RA2   READY    :1       //TS24 READY

// PORTB LCD SC1602 4bit DATA
//    RB0   trigger  :1;      //
//    RB1   rs       :1;      //
//    RB2   rw       :1;      //
//    RB3   enable   :1;      //
//    RB4:7 data     :4;      //
//
// PORTC
//    RC6   232TX    :1
//    RC7   232RX    :1
//
// 1. PORTB,TS24DEVBDŐڑĂ܂B
//   2. PORTC232TX,232RX,TS24DEVBDŐڑĂ܂B
//   3. PORTARA2́AڑĂ܂̂ŁAzĂB
//   4. LCDڑĂȂƃvO͓܂B
//   5. ^CAEĝ߃R}h荞݌A
//      2mŝv`hs܂B
//   6. gp̊ɍ킹ConfigurationBitsݒ肵ĂB
//                                                 20070724 REV0001
////////////////////////////////////////////////////////////////////
#include <p18F452.h>
#include <usart.h>
//#include "config.h"
#include "mylib.h"

////////////////////////////////////////////////
#define def_TXKAISU              20   //M

typedef unsigned int  int16;
typedef unsigned char int8;
/////////////////////////////////////////////////////
extern  char sai8_buffer0[128];      //232Mpobt@
extern  int8 si8_rx_cnt;             //232M
extern  int8 si1_rx_ok;              //232MtO
////////////////////////////////////////////////////
int8 si8_ch=1;                       //bgpϐ

/////////////////////////////////////////////QRQo
void rts_232out(int8 data){
    while(PORTAbits.RA2==1){           //READYhgh̊
    }
    send_232(data);
}
/////////////////////////////////////////////TS24 ݒ
void Ts24_Init(void){
    int8 i8_CH_H=0;
    int8 i8_CH_M=0;
    int8 i8_CH_L=0;
    
    si8_ch=1;                  //CH=1ɃZbg
    
    i8_CH_H=hex2asc( dec2ascfigure(si8_ch,3) );   //0->'0';
    i8_CH_M=hex2asc( dec2ascfigure(si8_ch,2) );   //0->'0';
    i8_CH_L=hex2asc( dec2ascfigure(si8_ch,1) );   //0->'1';

    //////////////////MODE SET
    rts_232out('#');
    rts_232out('6');
    rts_232out('6');
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(1000);             //reset̂ő҂
    //////////////////CH SET
    rts_232out('#');
    rts_232out('C');
    rts_232out('H');
    rts_232out(i8_CH_H);
    rts_232out(i8_CH_M);
    rts_232out(i8_CH_L);
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(10);              //READY "L"ȂΖĂǂ

    /////////////////////łM
    rts_232out('#');
    rts_232out('R');
    rts_232out('E');
    rts_232out('1');           //'0'ȂΕs
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(10);              //READY "L"ȂΖĂǂ
    /////////////////////hco͉
    rts_232out('#');
    rts_232out('I');
    rts_232out('E');
    rts_232out('1');           //'0'ȂΕs
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(10);              //READY "L"ȂΖĂǂ
    
}
//////////////////////////////////////////////////////M[`
void Command_Tx(int8 kaisu){
    
    int8 data[8];
    data[0]=hex2asc( dec2ascfigure(si8_ch,3) );
    data[1]=hex2asc( dec2ascfigure(si8_ch,2) );
    data[2]=hex2asc( dec2ascfigure(si8_ch,1) );
    data[3]=hex2asc( dec2ascfigure(kaisu,5));
    data[4]=hex2asc( dec2ascfigure(kaisu,4));
    data[5]=hex2asc( dec2ascfigure(kaisu,3));
    data[6]=hex2asc( dec2ascfigure(kaisu,2));
    data[7]=hex2asc( dec2ascfigure(kaisu,1));
    
    rts_232out('#');
    rts_232out('T');
    rts_232out('X');
    rts_232out('$');
    rts_232out(kaisu);
    rts_232out(si8_ch);
    rts_232out(def_TXKAISU);
    rts_232out('C');
    rts_232out('H');
    rts_232out(data[0]);
    rts_232out(data[1]);
    rts_232out(data[2]);
    rts_232out(data[3]);
    rts_232out(data[4]);
    rts_232out(data[5]);
    rts_232out(data[6]);
    rts_232out(data[7]);
    rts_232out('$');
    rts_232out(0x0d);
    delay_ms(2);        //R}h荞2ms҂
}
//////////////////////////////////////////////////////`lύX
void Change_Ch(int8 i_Ch_No){
    int temp1,temp2,temp3;
    temp1=hex2asc(dec2ascfigure(i_Ch_No,1));  //ASCIIɕύX
    temp2=hex2asc(dec2ascfigure(i_Ch_No,2));
    temp3=hex2asc(dec2ascfigure(i_Ch_No,3));
    ///////////////////////////1oCgƂREADYCHECK
    rts_232out('#');
    rts_232out('C');
    rts_232out('H');
    rts_232out(temp3);
    rts_232out(temp2);
    rts_232out(temp1);
    delay_ms(2);        //R}h荞2ms҂
}

///////////////////////////////////////////////////
void mode_normal(void){
    int temp;
    int i,k;
    int16 i16_rxloop=0;
    int16 i16_rxloop_cnt=0;

    
    lcd_init();                            //LCD module Init
    lcd_putstr("\fNow! Inintiarize\n");    // \f  clear display
    delay_ms(300);
    lcd_putstr("TS-24");
    lcd_putstr("TX TEST");

    Ts24_Init();                           //TS24 INIT
    lcd_putstr("\f³ݼޭ޶خ");
    temp=0;
    
    lcd_putstr("\f");
    while(TRUE){
        
        delay_ms(1000);
        for (i = 1; i < 83; i++) {
            lcd_putstr("\f");
            lcd_putstr("CH");
            lcd_putc( hex2asc( dec2ascfigure(i,3) ) );  //ASCIIɕύX
            lcd_putc( hex2asc( dec2ascfigure(i,2) ) );
            lcd_putc( hex2asc( dec2ascfigure(i,1) ) );
            lcd_locxy(7,1);       //LCD\ʒuSET
            lcd_putstr( " ݺ    " );
            
            si8_ch=i;
            Change_Ch(si8_ch);        //gς
            delay_ms(500);            //Mɍ킹ēKXς
            lcd_locxy(7,1);       //LCD\ʒuSET
            lcd_putstr( "  " );
            //def_TXKAISUŌ߂ꂽ񐔑M
            for (k = 1; k < (def_TXKAISU+1); k++) {
                lcd_locxy(0,0);       //LCD\ʒuSET
                lcd_putstr("TXcnt=");
                lcd_putc( hex2asc( dec2ascfigure(k,3) ) );  //ASCIIɕύX
                lcd_putc( hex2asc( dec2ascfigure(k,2) ) );
                lcd_putc( hex2asc( dec2ascfigure(k,1) ) );
                //M[`
                Command_Tx(k);
                delay_ms(60);         //Mɍ킹ēKXς
            }
        }
        
    }
}

////////////////////////////////////////////////////
void main(void){
    int temp;
    INTCON = 0x00;                //disable global
    INTCON2 = 0x84;               //TMR0 high priority
    RCONbits.IPEN = 1;            //enable priority levels
    TMR0H = 0;                    //clear timer
    TMR0L = 0;                    //clear timer
    T0CON = 0x82;                 //set up timer0 - prescaler 1:8
    ADCON1 = 0b00000110;          //AD OFF
    //////////////////////////////////////////////////////I/O set
    TRISA =(0b00100101);       // PORT A
    TRISB =(0b00000000);       // PORT B
    TRISC =(0b10011001);       // PORT C
    TRISD =(0b11110111);       // PORT D
    TRISE =(0b00000001);       // PORT E
    
    port_b_pullups();      //PORTB pullup ON
    temp=0;
    open_232(def_SPEED);   //Open USART 8N1,19200baud
    si8_ch=1;              //CH=1
    
    while(TRUE){
        mode_normal();
    }
}
