/////////////////////////////////////////////////////////////////
// TS24 test tool RX
//      using TS24 DEVBD
//
// PORTA 
//    RA2   READY    :1       //TS24 READY
//
// PORTB LCD SC1602 4bit DATA
//    RB0   trigger  :1;      //
//    RB1   rs       :1;      //
//    RB2   rw       :1;      //
//    RB3   enable   :1;      //
//    RB4:7 data     :4;      //
//
// PORTC
//    RC6   232TX    :1
//    RC7   232RX    :1
//
// 1. PORTB,TS24DEVBDŐڑĂ܂B
//   2. PORTC232TX,232RX,TS24DEVBDŐڑĂ܂B
//   3. PORTARA2́AڑĂ܂̂ŁAzĂB
//   4. LCDڑĂȂƃvO͓܂B
//   5. ^CAEĝ߃R}h荞݌A
//      2mŝv`hs܂B
//   6. gp̊ɍ킹ConfigurationBitsݒ肵ĂB
//                                            20070724 REV0001
/////////////////////////////////////////////////////////////////
#include <p18F452.h>
#include <usart.h>
//#include "config.h"
#include "mylib.h"

////////////////////////////////////////////////


typedef unsigned int  int16;
typedef unsigned char int8;
/////////////////////////////////////////////////////
extern  char sai8_buffer0[128];      //232Mpobt@
extern  int8 si8_rx_cnt;             //232M
extern  int8 si1_rx_ok;              //232MtO
///////////////////////////////////////////////////////////////
int8 si8_ch=1;                       //bgpϐ

//////////////////////////////////////////////////////////////
int8 si8_RxDataLen;        //Mf[^
int8 si8_RxFromId_H;       //MTXID_H
int8 si8_RxFromId_L;       //MTXID_L
int8 si8_RxCh_No;          //M`lԍ
int8 si8_RxIdent;          //Mʕ
int8 si8_RxToId_H;         //MRXID_H
int8 si8_RxToId_L;         //MRXID_L

int16 si16_RXID=0;         //MID
int8 sai8_Rxdata[16];      //MDATAi[
int8 si8_rxin_cnt=0;       //MJEg



/////////////////////////////////////////////QRQo
void rts_232out(int8 data){
    while(PORTAbits.RA2==1){           //READYhgh̊
    }
    send_232(data);
}

/////////////////////////////////////////////TS24 INIT
void Ts24_Init(void){
    int8 i8_CH_H=0;
    int8 i8_CH_M=0;
    int8 i8_CH_L=0;
    
    si8_ch=1;             //CH=1ɃZbg
    
    i8_CH_H=hex2asc( dec2ascfigure(si8_ch,3) );   //0->'0';
    i8_CH_M=hex2asc( dec2ascfigure(si8_ch,2) );   //0->'0';
    i8_CH_L=hex2asc( dec2ascfigure(si8_ch,1) );   //0->'1';

    //////////////////MODE SET
    rts_232out('#');
    rts_232out('6');
    rts_232out('6');
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(1000);     //reset̂ő҂
    //////////////////CH SET
    rts_232out('#');
    rts_232out('C');
    rts_232out('H');
    rts_232out(i8_CH_H);
    rts_232out(i8_CH_M);
    rts_232out(i8_CH_L);
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(10);       //READY "L"ȂΖĂǂ

    /////////////////////łM
    rts_232out('#');
    rts_232out('R');
    rts_232out('E');
    rts_232out('1');
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(10);       //READY "L"ȂΖĂǂ
    /////////////////////hco͉
    rts_232out('#');
    rts_232out('I');
    rts_232out('E');
    rts_232out('1');
    delay_ms(2);        //R}h荞2ms҂
    delay_ms(10);       //READY "L"ȂΖĂǂ
}

/////////////////////////////////////////////`lύX
void Change_Ch(int8 i_Ch_No){
    int temp1,temp2,temp3;
    temp1=hex2asc(dec2ascfigure(i_Ch_No,1));   //ASCIIɕύX
    temp2=hex2asc(dec2ascfigure(i_Ch_No,2));
    temp3=hex2asc(dec2ascfigure(i_Ch_No,3));
    ///////////////////////////1oCgƂREADYCHECK
    rts_232out('#');
    rts_232out('C');
    rts_232out('H');
    rts_232out(temp3);
    rts_232out(temp2);
    rts_232out(temp1);
    delay_ms(2);        //R}h荞2ms҂
}
///////////////////////////////////////////////////////////////////////
int8 Get_data(void){
    int i;
    if(sai8_buffer0[7] =='$' && sai8_buffer0[21] =='$'){    //Mf[^؂CHECK(Ăǂ j
        si8_RxDataLen  = sai8_buffer0[0];    //f[^
        si8_RxFromId_H = sai8_buffer0[1];    //MhcQg
        si8_RxFromId_L = sai8_buffer0[2];    //MhcQk
        si8_RxToId_H   = sai8_buffer0[3];    //MhcQg
        si8_RxToId_L   = sai8_buffer0[4];    //MhcQk
        si8_RxCh_No    = sai8_buffer0[5];    //bg
        si8_RxIdent    = sai8_buffer0[6];    //Ǘmn
        ///////////////////////////Mf[^
        for(i=0;i<16;i++){
            sai8_Rxdata[i]     =sai8_buffer0[8+i];
        }
        ///////////////////////////Mf[^

        si16_RXID=  si8_RxFromId_H *256+si8_RxFromId_L;
        
        return(TRUE);
    }else{
        
        return(FALSE);
    }
    
}

///////////////////////////////////////////////////
void mode_normal(void){
    int temp;
    int i,k;
    int16 i16_timrout0=0;               //^CAEgpϐ
    int8 i1_first_rx=FALSE;             //MtO
    int8 i8_rxcnt=0;                    //M񐔗pϐ
    lcd_init();                         //LCD INIT
    lcd_putstr("\fNow! Inintiarize\n");
    delay_ms(300);
    lcd_putstr("\fTS-24\n");            // \f  clear display
    lcd_putstr("RX TEST");
    temp=0;
    i1_first_rx=FALSE;
    i8_rxcnt=0;
    Ts24_Init();                        //TS24 INIT     
    lcd_putstr("\f³ݼޭ޶خ");
    clear_buf(&sai8_buffer0[0]);        //obt@NA
    clear_232rxbuf();                   //232obt@NA
    clear_interrupt(INT_RDA);           //232荞݃NA
    enable_interrupts(INT_RDA);         //232荞݂nm
    enable_interrupts(GLOBAL);          //荞݂nm
    si1_rx_ok=FALSE;
    while(TRUE){
        if(si1_rx_ok==TRUE){            //232f[^Ȃ
            si1_rx_ok=FALSE;
            disable_interrupts(GLOBAL); //荞݋֎~
            if(Get_data() ==TRUE){
                i1_first_rx=TRUE;
                i16_timrout0=0;
                lcd_locxy(1,1);                //LCD\ʒuSET
                lcd_putstr("ID=");
                lcd_putc( hex2asc( hex2ascfigure(si16_RXID,4) ) );  //ASCIIɕύX
                lcd_putc( hex2asc( hex2ascfigure(si16_RXID,3) ) );
                lcd_putc( hex2asc( hex2ascfigure(si16_RXID,2) ) );
                lcd_putc( hex2asc( hex2ascfigure(si16_RXID,1) ) );
                lcd_putc(' ');
                i8_rxcnt++;
                lcd_putstr("RXcnt=");         //M񐔕\
                lcd_putc( hex2asc( dec2ascfigure(i8_rxcnt,2) ) );   //ASCIIɕύX
                lcd_putc( hex2asc( dec2ascfigure(i8_rxcnt,1) ) );
                lcd_locxy(1,0);
                //Mf[^\
                for(i=3;i<13;i++){
                    lcd_putc(sai8_Rxdata[i]);
                }
                
            }
            clear_buf(&sai8_buffer0[0]);       //obt@NA
            enable_interrupts(GLOBAL);         //荞݂nm
        }
        if(i1_first_rx==TRUE){;
            i16_timrout0++;
            if(i16_timrout0>5000){         //M^CAEgȂ
                i8_rxcnt=0;
                i1_first_rx=FALSE;
                //lcd_putc('\f');
                if(si8_ch<82){
                    si8_ch++;
                    Change_Ch(si8_ch);
                }else{
                    si8_ch=1;
                    Change_Ch(1);
                    
                }
            }
        }
        
    }
}

///////////////////////////////////////////////////////////

////////////////////////////////////////////////
void main() {
    int temp;
    INTCON = 0x00;                //disable global
    INTCON2 = 0x84;               //TMR0 high priority
    RCONbits.IPEN = 1;            //enable priority levels
    TMR0H = 0;                    //clear timer
    TMR0L = 0;                    //clear timer
    T0CON = 0x82;                 //set up timer0 - prescaler 1:8
    ADCON1 = 0b00000110;          //AD OFF
    //////////////////////////////////////////////////////I/O set
    TRISA =(0b00100001);       // PORT A
    TRISB =(0b00000000);       // PORT B
    TRISC =(0b10011001);       // PORT C
    TRISD =(0b11110111);       // PORT D
    TRISE =(0b00000001);       // PORT E
    
    port_b_pullups();      //PORTB pullup ON
    
    temp=0;
    open_232(def_SPEED);   //Open USART 8N1,19200baud
    si8_ch=1;
    
    disable_interrupts(INT_RDA);  //232rx interrupts ֎~
    disable_interrupts(GLOBAL);   //all interrupts ֎~
    while(TRUE){
        mode_normal();
    }
}
